//*****************************************************************************
//*****************************************************************************
//  FILENAME: PWM8_BAUD.h
//   Version: 2.4, Updated on 2004/10/27 at 18:26:18
//  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
//
//  DESCRIPTION: PWM8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 PWM8_BAUD_EnableInt
#pragma fastcall16 PWM8_BAUD_DisableInt
#pragma fastcall16 PWM8_BAUD_Start
#pragma fastcall16 PWM8_BAUD_Stop
#pragma fastcall16 PWM8_BAUD_bReadCounter              // Read  DR0
#pragma fastcall16 PWM8_BAUD_WritePeriod               // Write DR1
#pragma fastcall16 PWM8_BAUD_bReadPulseWidth           // Read  DR2
#pragma fastcall16 PWM8_BAUD_WritePulseWidth           // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bPWM8_BAUD_ReadCounter              // Read  DR0 (Deprecated)
#pragma fastcall16 bPWM8_BAUD_ReadPulseWidth           // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the PWM8_BAUD API.
//-------------------------------------------------

extern void PWM8_BAUD_EnableInt(void);                        // Proxy Class 1
extern void PWM8_BAUD_DisableInt(void);                       // Proxy Class 1
extern void PWM8_BAUD_Start(void);                            // Proxy Class 1
extern void PWM8_BAUD_Stop(void);                             // Proxy Class 1
extern BYTE PWM8_BAUD_bReadCounter(void);                     // Proxy Class 2
extern void PWM8_BAUD_WritePeriod(BYTE bPeriod);              // Proxy Class 1
extern BYTE PWM8_BAUD_bReadPulseWidth(void);                  // Proxy Class 1
extern void PWM8_BAUD_WritePulseWidth(BYTE bPulseWidth);      // Proxy Class 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bPWM8_BAUD_ReadCounter(void);            // Deprecated
extern BYTE bPWM8_BAUD_ReadPulseWidth(void);         // Deprecated


//--------------------------------------------------
// Constants for PWM8_BAUD API's.
//--------------------------------------------------

#define PWM8_BAUD_CONTROL_REG_START_BIT        ( 0x01 )
#define PWM8_BAUD_INT_REG_ADDR                 ( 0x0e1 )
#define PWM8_BAUD_INT_MASK                     ( 0x02 )


//--------------------------------------------------
// Constants for PWM8_BAUD user defined values
//--------------------------------------------------

#define PWM8_BAUD_PERIOD                       ( 0x33 )
#define PWM8_BAUD_PULSE_WIDTH                  ( 0x1a )


//-------------------------------------------------
// Register Addresses for PWM8_BAUD
//-------------------------------------------------

#pragma ioport  PWM8_BAUD_COUNTER_REG:  0x024              //DR0 Count register
BYTE            PWM8_BAUD_COUNTER_REG;
#pragma ioport  PWM8_BAUD_PERIOD_REG:   0x025              //DR1 Period register
BYTE            PWM8_BAUD_PERIOD_REG;
#pragma ioport  PWM8_BAUD_COMPARE_REG:  0x026              //DR2 Compare register
BYTE            PWM8_BAUD_COMPARE_REG;
#pragma ioport  PWM8_BAUD_CONTROL_REG:  0x027              //Control register
BYTE            PWM8_BAUD_CONTROL_REG;
#pragma ioport  PWM8_BAUD_FUNC_REG: 0x124                  //Function register
BYTE            PWM8_BAUD_FUNC_REG;
#pragma ioport  PWM8_BAUD_INPUT_REG:    0x125              //Input register
BYTE            PWM8_BAUD_INPUT_REG;
#pragma ioport  PWM8_BAUD_OUTPUT_REG:   0x126              //Output register
BYTE            PWM8_BAUD_OUTPUT_REG;
#pragma ioport  PWM8_BAUD_INT_REG:       0x0e1             //Interrupt Mask Register
BYTE            PWM8_BAUD_INT_REG;


//-------------------------------------------------
// PWM8_BAUD Macro 'Functions'
//-------------------------------------------------

#define PWM8_BAUD_Start_M \
   PWM8_BAUD_CONTROL_REG |=  PWM8_BAUD_CONTROL_REG_START_BIT

#define PWM8_BAUD_Stop_M  \
   PWM8_BAUD_CONTROL_REG &= ~PWM8_BAUD_CONTROL_REG_START_BIT

#define PWM8_BAUD_EnableInt_M   \
   M8C_EnableIntMask(PWM8_BAUD_INT_REG, PWM8_BAUD_INT_MASK)

#define PWM8_BAUD_DisableInt_M  \
   M8C_DisableIntMask(PWM8_BAUD_INT_REG, PWM8_BAUD_INT_MASK)


// end of file PWM8_BAUD.h
