;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: I2Cm_1.inc
;;   Version: 1.4, Updated on 2004/10/27 at 18:25:50
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Assembler declarations for the I2Cm user module interface for
;;               the 22/24/25/26/27xxx PSoC family of devices.
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

;--------------------------------------------------
; Constants for I2Cm_1 API's
;--------------------------------------------------
;24 MHz
I2Cm_1_delayqtr:     equ   2            ; Define delays for proper timing at 24 MHz
I2Cm_1_delayhalf:    equ   5
I2Cm_1_delay3qtr:    equ   12

;12 MHz
;I2Cm_1_delayqtr:    equ   3
;I2Cm_1_delayhalf:   equ   3
;I2Cm_1_delay3qtr:   equ   3

I2Cm_1_SDA_pin:      equ   1h ; bit number of for SDA
I2Cm_1_SCL_pin:      equ   2h ; bit number of for SCL
I2Cm_1_I2CPortNum:   equ   1h     ; Port number to use for I2C Both pins will be on this port


;-----------------
; Bank 0
;-----------------
I2Cm_1_I2CPRTDR:     equ   PRT1DR  ; Port number to use for I2C Both pins will be on this port

;-----------------
; Bank 1
;-----------------

I2Cm_1_I2CPRTDM0:                      equ   PRT1DM0  ; Port number to use for I2C Both pins will be on this port
I2Cm_1_I2CPRTDM1:                      equ   PRT1DM1  ; Port number to use for I2C Both pins will be on this port

;-----------------
; Misc
;-----------------
I2Cm_1_READ:           equ  0x01 ; Set the R/W flag after the slave address.
I2Cm_1_WRITE:          equ  0x00 ; Clear the R/W flag after the slave address.
I2Cm_1_XFER_ERROR:     equ  0x00 ; Slave did not ACK
I2Cm_1_XFER_COMPLETE:  equ  0x01 ; Returned if Slave did ACK

I2Cm_1_ComleteXfer:    equ  0x00 ; Perform a complete I2C transfer
I2Cm_1_RepStart:       equ  0x01 ; Perform a complete transfer with a Repeat Start
I2Cm_1_NoStop:         equ  0x02 ; Perform a complete transfer, but leave off the stop.

I2Cm_1_NAKslave:       equ  0x00 ; NAK the slave after a read
I2Cm_1_ACKslave:       equ  0x01 ; ACK the slave after a read

; end of file I2Cm_1.inc
