package maslab.telemetry.botclient;
import maslab.telemetry.JugMessageListener;

/** To write a plugin, implement this interface.  Your constructor
 * must be of the form:

 public MyPlugin(javax.swing.JInternalFrame frame) 
 
 This give you a JInternalFrame to draw on.  At present, your plugin
 must be in the default namespace, or within
 maslab.telemetry.botclient.

 You can also optionally implement maslab.util.StatusListener, in
 which case you will receive connection/disconnection events from the
 relevant JugClient.

**/

public interface Plugin extends JugMessageListener
{
    // A comma-separated list of types that this plugin can handle.
    public static final String types = "";

    // Return true if you can properly handle this new channel
    // (without dropping any existing channels).  <type> will always
    // be one of the types you listed in "types" above.
    public boolean addChannel(String name,String type);

    // Self explanatory
    public void removeChannel(String name);

    // Handle data
    public void messageReceived(String channel, byte[] data);


}
